<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeriesCctERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeriesCctERP
 * @subpackage Arrays
 */
class ArrayOfSeriesCctERP extends AbstractStructArrayBase
{
    /**
     * The SeriesCctERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SeriesCctERP[]
     */
    public $SeriesCctERP;
    /**
     * Constructor method for ArrayOfSeriesCctERP
     * @uses ArrayOfSeriesCctERP::setSeriesCctERP()
     * @param \StructType\SeriesCctERP[] $seriesCctERP
     */
    public function __construct(array $seriesCctERP = array())
    {
        $this
            ->setSeriesCctERP($seriesCctERP);
    }
    /**
     * Get SeriesCctERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SeriesCctERP[]|null
     */
    public function getSeriesCctERP()
    {
        return isset($this->SeriesCctERP) ? $this->SeriesCctERP : null;
    }
    /**
     * Set SeriesCctERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesCctERP[] $seriesCctERP
     * @return \ArrayType\ArrayOfSeriesCctERP
     */
    public function setSeriesCctERP(array $seriesCctERP = array())
    {
        foreach ($seriesCctERP as $arrayOfSeriesCctERPSeriesCctERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeriesCctERPSeriesCctERPItem instanceof \StructType\SeriesCctERP) {
                throw new \InvalidArgumentException(sprintf('The SeriesCctERP property can only contain items of \StructType\SeriesCctERP, "%s" given', is_object($arrayOfSeriesCctERPSeriesCctERPItem) ? get_class($arrayOfSeriesCctERPSeriesCctERPItem) : gettype($arrayOfSeriesCctERPSeriesCctERPItem)), __LINE__);
            }
        }
        if (is_null($seriesCctERP) || (is_array($seriesCctERP) && empty($seriesCctERP))) {
            unset($this->SeriesCctERP);
        } else {
            $this->SeriesCctERP = $seriesCctERP;
        }
        return $this;
    }
    /**
     * Add item to SeriesCctERP value
     * @throws \InvalidArgumentException
     * @param \StructType\SeriesCctERP $item
     * @return \ArrayType\ArrayOfSeriesCctERP
     */
    public function addToSeriesCctERP(\StructType\SeriesCctERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SeriesCctERP) {
            throw new \InvalidArgumentException(sprintf('The SeriesCctERP property can only contain items of \StructType\SeriesCctERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SeriesCctERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SeriesCctERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SeriesCctERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SeriesCctERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SeriesCctERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SeriesCctERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeriesCctERP
     */
    public function getAttributeName()
    {
        return 'SeriesCctERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfSeriesCctERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
